
module Rule
  def htmlBody(cgi)
    [ [@target_extension],
      [@src, @dst, @proto],
      [@in_if, @out_if, @fragmentation],
      [@extension],
      [@statistics],
      [@action_container]
    ].map {|row| 
      	"<tr#{cellAttr} align=center valign=top>" +
	    row.map{|col|
	      lb = Core::Leaf===col ? col.option('label') : ''
	      width = (col==row.last) ? 
		(row.size<3 ? " colspan=#{4-row.size}" : '') : ''
	      "<td#{width}>#{lb}  #{col ? col.html(cgi) : ''}</td>"
	    }.join(' ') + '</tr>'
      }.join("\n") 
      #children.grep(Core::Action) {|x| x.html(cgi)}.join('')
  end
end

module NetworkAddress
  def htmlBody(cgi)
    "<tr#{cellAttr}>" +
      [@ip, @netmask, @bool].map {|x| htmlItem(cgi, x)}.join('') +
    '</tr>'
  end
end

module Protocol
  def htmlBody(cgi)
    "<tr#{cellAttr}>" +
      [@proto, @bool].map {|x| htmlItem(cgi, x)}.join('') +
    '</tr>'
  end
end

module Target_Extension_Container
  def htmlBody(cgi)
    "<tr#{cellAttr} valign=\"top\">" +
      (@target ? "<td>#{@target.html(cgi)}</td>" : '') +
      "<td>" + @jump_target.html(cgi) + @action.html(cgi) + "</td>" +
    "</tr>"
    #"<tr#{cellAttr}>"+children.map{|x| htmlItem(cgi, x)}.join('')+"<tr>"
  end

  def htmlItem(cgi,x)
    "<td>"+ x.html(cgi)+"</td>"
  end
end

module Extension_Container

  def htmlBody(cgi)
	"<tr#{cellAttr}><td colspan=\"100\">" +
	@extension_selector.html(cgi) + @action.html(cgi) +
	"</td></tr>\n<tr valign=\"top\" #{cellAttr}>" +
	children.grep(Plugin::Firewall::Extension) {|x| htmlItem(cgi,x)}.join("\n") + "</tr>"
  end

  def htmlItem(cgi,x)
    "<td>"+ x.html(cgi)+"</td>"
  end

end

# Standard procedure to make a deep copy of defined methods into provided namespace
# Note that Module#include does not copy anything deeper than first level
# so we must do this ourselves
def self.append_features(amod)
   constants.each do |const|
      amod.module_eval("class #{const}; include #{self.to_s}::#{const}; end")
   end
end
